<?php
/**
* SERVIRED per Arluk Software, S.L.
*basado en notify.php del core de virtuemart
*
*/

if ($_POST) {
   header("HTTP/1.0 200 OK");

    global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database,
    $mosConfig_mailfrom, $mosConfig_fromname;

        /*** access Joomla's configuration file ***/
        $my_path = dirname(__FILE__);

        if( file_exists($my_path."/../../../configuration.php")) {
            $absolute_path = dirname( $my_path."/../../../configuration.php" );
            require_once($my_path."/../../../configuration.php");
        }
        elseif( file_exists($my_path."/../../configuration.php")){
            $absolute_path = dirname( $my_path."/../../configuration.php" );
            require_once($my_path."/../../configuration.php");
        }
        elseif( file_exists($my_path."/configuration.php")){
            $absolute_path = dirname( $my_path."/configuration.php" );
            require_once( $my_path."/configuration.php" );
        }
        else {
            die( "Joomla Configuration File not found!" );
        }

        $absolute_path = realpath( $absolute_path );

        // Set up the appropriate CMS framework
        if( class_exists( 'jconfig' ) ) {
			define( '_JEXEC', 1 );
			define( 'JPATH_BASE', $absolute_path );
			define( 'DS', DIRECTORY_SEPARATOR );

			// Load the framework
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );

			// create the mainframe object
			$mainframe = & JFactory::getApplication( 'site' );

			// Initialize the framework
			$mainframe->initialise();

			// load system plugin group
			JPluginHelper::importPlugin( 'system' );

			// trigger the onBeforeStart events
			$mainframe->triggerEvent( 'onBeforeStart' );
			$lang =& JFactory::getLanguage();
			$mosConfig_lang = $GLOBALS['mosConfig_lang']          = strtolower( $lang->getBackwardLang() );
			// Adjust the live site path
			$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
			$mosConfig_absolute_path = JPATH_BASE;
        } else {
        	define('_VALID_MOS', '1');
        	require_once($mosConfig_absolute_path. '/includes/joomla.php');
        	require_once($mosConfig_absolute_path. '/includes/database.php');
        	$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
        	$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
        }

       // load Joomla Language File
        if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' )) {
            require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
        }
        elseif (file_exists( $mosConfig_absolute_path. '/language/english.php' )) {
            require_once( $mosConfig_absolute_path. '/language/english.php' );
        }
    /*** END of Joomla config ***/ /*** VirtueMart part ***/
        require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
        include_once( ADMINPATH.'/compat.joomla1.5.php' );
        require_once( ADMINPATH. 'global.php' );
        require_once( CLASSPATH. 'ps_main.php' );

        /* @MWM1: Logging enhancements (file logging & composite logger). */
        $vmLogIdentifier = "notify.php";
        require_once(CLASSPATH."Log/LogInit.php");


		$debug_email_address = $mosConfig_mailfrom;
	    // restart session
	    // Constructor initializes the session!
	    $sess = new ps_session();

    /*** END VirtueMart part ***/


    //1. Finished Initialization of the notify_servired.php script"

    /**
    * Read post from Servired system and update order status
    **/
    $i = 1;

    $Ds_Date = trim(stripslashes($_POST['Ds_Date']));
    $Ds_Hour = trim(stripslashes($_POST['Ds_Hour']));
    $Ds_Amount = trim(stripslashes($_POST['Ds_Amount']));
    $Ds_Currency = trim(stripslashes($_POST['Ds_Currency']));
    $Ds_Order = trim(stripslashes($_POST['Ds_Order']));

    // Can be USD, GBP, EUR, CAD, JPY
    $Ds_MerchantCode =  trim(stripslashes($_POST['Ds_MerchantCode']));

    $Ds_Terminal = trim(stripslashes($_POST['Ds_Terminal']));
    $Ds_Signature = trim(stripslashes($_POST['Ds_Signature']));
	//respuesta de la transaccin valores entre 0000 a 0099 indican que correcto
    $Ds_Response = trim(stripslashes($_POST['Ds_Response']));

    $Ds_TransactionType = trim(stripslashes($_POST['Ds_TransactionType']));
    $Ds_AuthorisationCode =  trim(stripslashes($_POST['Ds_AuthorisationCode']));


      // Get the Order Details from the database
      // Get the Order Details from the database
      $qv = "SELECT `order_id`, `order_number`, `user_id`, `order_subtotal`,
                    `order_total`, `order_currency`, `order_tax`,
                    `order_shipping_tax`, `coupon_discount`, `order_discount`
                FROM `#__{vm}_orders`
                WHERE `order_id`='".intval($Ds_Order)."'";
      $db = new ps_DB;
      $db->query($qv);
      $db->next_record();
      $order_id = $db->f("order_id");

      $d['order_id'] = $order_id;
      $d['notify_customer'] = "Y";

	 	$clave='clave_negocio';                     // Clave de comercio proporcionada por Sermepa.
		$name='nombre_negocio';                        // Nombre del comercio que sale en la transaccion.
		$code='codigo_negocio';                        // Codigo de comercio proporcionado por Sermepa.
		$terminal='1';                                      // Terminal usado.
		$currency='978';                                      // 978=Euros.
		$tipoOperacion='0';                                   // Tipo de operacion. 0=Autorizacion.
				// Calculo del hash para firmar los datos.
		$order = '000'.$order_id;
		$amount=$db->f("order_total")*100;
		$message = $amount.$order.$code.$currency.$Ds_Response.$clave;
		$signature = strtoupper(sha1($message));
     if($Ds_Signature==$signature){
			//-------------------------------------------
		  // ...read the results of the verification...
		  // If $Ds_Response esta entre 0000 y 0099 la transaccin ha ido bien
		  //-------------------------------------------
		if (intval ( $Ds_Response)>=0 &&  intval ( $Ds_Response)<100 ) {

			// UPDATE THE ORDER STATUS to 'Completed'
				$d['order_status'] = "C";
			require_once ( CLASSPATH . 'ps_order.php' );
                $ps_order= new ps_order;
                $ps_order->order_status_update($d);
			/*$mail->From = $mosConfig_mailfrom;
			$mail->FromName = $mosConfig_fromname;
			$mail->AddAddress($debug_email_address);
			$mail->Subject = "SERVIRED IPN txn on your site";
			$mail->Body = "Hello,\n\n";
			$mail->Body .= "a SERVIRED transaction for you has been made on your website!\n";
			$mail->Body .= "-----------------------------------------------------------\n";
			$mail->Body .= "Order ID: $order_id\n";
			$mail->Body .= "Payment Status returned by SERVIRED: $Ds_Response\n";
			$mail->Body .= "Order Status Code: ".$d['order_status'];
			$mail->Send();*/
			$mailsubject= "SERVIRED IPN txn on your site";
			$mailbody= "Hello,\n\n";
			$mailbody .= "a SERVIRED transaction for you has been made on your website!\n";
			$mailbody .= "-----------------------------------------------------------\n";
			$mailbody .= "Order ID: $order_id\n";
			$mailbody .= "Payment Status returned by SERVIRED: $Ds_Response\n";
			$mailbody .= "Order Status Code: ".$d['order_status'];
			 vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
		}
		else {
				$d['order_status'] = "X";
			require_once ( CLASSPATH . 'ps_order.php' );
                $ps_order= new ps_order;
                $ps_order->order_status_update($d);
				/*$mail->From = $mosConfig_mailfrom;
				$mail->FromName = $mosConfig_fromname;
				$mail->AddAddress($debug_email_address);
				$mail->Subject = "SERVIRED Transaction on your Site";
				$mail->Body = "Hello,
				An error occured while processing a SERVIRED transaction.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response";
				$mail->Send();*/
				$mailsubject= "SERVIRED Transaction on your Site";
			$mailbody= "Hello,
				An error occured while processing a SERVIRED transaction.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response";

			 vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
		}
	 }
	 else{
	 	/*$mail->From = $mosConfig_mailfrom;
				$mail->FromName = $mosConfig_fromname;
				$mail->AddAddress($debug_email_address);
				$mail->Subject = "SERVIRED Transaction on your Site";
				$mail->Body = "Hello,
				Se ha recibido una transaccin de SERVIRED con una firma erronea.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response\n
					Cantidad recibida= $Ds_Amount.
					Cantidad pedido: $amount.
					order_servired=$Ds_Order\n
					Firma recibida=$Ds_Signature\n
					Firma generada=$signature\n
					";

				$mail->Send();*/
				$mailsubject= "SERVIRED Transaction on your Site";
			$mailbody= "Hello,
				Se ha recibido una transaccin de SERVIRED con una firma erronea.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response\n
					Cantidad recibida= $Ds_Amount.
					Cantidad pedido: $amount.
					order_servired=$Ds_Order\n
					Firma recibida=$Ds_Signature\n
					Firma generada=$signature\n
					";

			 vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
	 }

}
?>
